Index: trunk/src/VBox/Devices/Network/slirp/ip_icmp.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/ip_icmp.c	(revision 33974)
+++ trunk/src/VBox/Devices/Network/slirp/ip_icmp.c	(revision 33978)
@@ -275,5 +275,5 @@
 
         default:
-            LogRel(("%s:ICMP: unsupported protocol(%d)\n", __FUNCTION__, ip->ip_p));
+            Log(("NAT:ICMP: unsupported protocol(%d)\n", ip->ip_p));
     }
     sofound:
@@ -283,5 +283,5 @@
         {
             /* socket is shutdowning we've already sent ICMP on it.*/
-            LogRel(("NAT: Received icmp on shutdowning socket (probably corresponding ICMP socket has been already sent)\n"));
+            Log(("NAT: Received icmp on shutdowning socket (probably corresponding ICMP socket has been already sent)\n"));
             return NULL;
         }
@@ -366,5 +366,5 @@
         if (!icp_buf)
         {
-            LogRel(("NAT: not enought memory to allocate the buffer\n"));
+            Log(("NAT: not enought memory to allocate the buffer\n"));
             goto end_error_free_m;
         }
@@ -427,5 +427,5 @@
                                         (void *)&ttl, sizeof(ttl));
                     if (status < 0)
-                        LogRel(("NAT: Error (%s) occurred while setting TTL attribute of IP packet\n",
+                        Log(("NAT: Error (%s) occurred while setting TTL attribute of IP packet\n",
                                 strerror(errno)));
                     rc = sendto(pData->icmp_socket.s, icp, icmplen, 0,
@@ -475,21 +475,21 @@
                     goto done;
                 }
-                LogRel(("NAT: Error (%d) occurred while sending ICMP (", error));
+                Log(("NAT: Error (%d) occurred while sending ICMP (", error));
                 switch (error)
                 {
                     case ERROR_INVALID_PARAMETER:
-                        LogRel(("icmp_socket:%lx is invalid)\n", pData->icmp_socket.s));
+                        Log(("icmp_socket:%lx is invalid)\n", pData->icmp_socket.s));
                         break;
                     case ERROR_NOT_SUPPORTED:
-                        LogRel(("operation is unsupported)\n"));
+                        Log(("operation is unsupported)\n"));
                         break;
                     case ERROR_NOT_ENOUGH_MEMORY:
-                        LogRel(("OOM!!!)\n"));
+                        Log(("OOM!!!)\n"));
                         break;
                     case IP_BUF_TOO_SMALL:
-                        LogRel(("Buffer too small)\n"));
+                        Log(("Buffer too small)\n"));
                         break;
                     default:
-                        LogRel(("Other error!!!)\n"));
+                        Log(("Other error!!!)\n"));
                         break;
                 }
Index: trunk/src/VBox/Devices/Network/slirp/slirp.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 33974)
+++ trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 33978)
@@ -286,10 +286,10 @@
     if (ret != ERROR_BUFFER_OVERFLOW)
     {
-        LogRel(("NAT: error %lu occurred on capacity detection operation\n", ret));
+        Log(("NAT: error %lu occurred on capacity detection operation\n", ret));
         return -1;
     }
     if (size == 0)
     {
-        LogRel(("NAT: Win socket API returns non capacity\n"));
+        Log(("NAT: Win socket API returns non capacity\n"));
         return -1;
     }
@@ -298,5 +298,5 @@
     if (!pAdapterAddr)
     {
-        LogRel(("NAT: No memory available \n"));
+        Log(("NAT: No memory available \n"));
         return -1;
     }
@@ -304,5 +304,5 @@
     if (ret != ERROR_SUCCESS)
     {
-        LogRel(("NAT: error %lu occurred on fetching adapters info\n", ret));
+        Log(("NAT: error %lu occurred on fetching adapters info\n", ret));
         RTMemFree(pAdapterAddr);
         return -1;
@@ -330,10 +330,10 @@
             if (!pDns)
             {
-                LogRel(("NAT: Can't allocate buffer for DNS entry\n"));
+                Log(("NAT: Can't allocate buffer for DNS entry\n"));
                 RTMemFree(pAdapterAddr);
                 return VERR_NO_MEMORY;
             }
 
-            LogRel(("NAT: adding %R[IP4] to DNS server list\n", &InAddr));
+            Log(("NAT: adding %R[IP4] to DNS server list\n", &InAddr));
             if ((InAddr.s_addr & RT_H2N_U32_C(IN_CLASSA_NET)) == RT_N2H_U32_C(INADDR_LOOPBACK & IN_CLASSA_NET))
                 pDns->de_addr.s_addr = RT_H2N_U32(RT_N2H_U32(pData->special_addr.s_addr) | CTL_ALIAS);
@@ -370,5 +370,5 @@
                 if (!pDomain)
                 {
-                    LogRel(("NAT: not enough memory\n"));
+                    Log(("NAT: not enough memory\n"));
                     RTStrFree(pszSuffix);
                     RTMemFree(pAdapterAddr);
@@ -376,5 +376,5 @@
                 }
                 pDomain->dd_pszDomain = pszSuffix;
-                LogRel(("NAT: adding domain name %s to search list\n", pDomain->dd_pszDomain));
+                Log(("NAT: adding domain name %s to search list\n", pDomain->dd_pszDomain));
                 LIST_INSERT_HEAD(&pData->pDomainList, pDomain, dd_list);
             }
@@ -421,5 +421,5 @@
     RTFILE f;
     int cNameserversFound = 0;
-    int fWarnTooManyDnsServers = 0;
+    bool fWarnTooManyDnsServers = false;
     struct in_addr tmp_addr;
     int rc;
@@ -474,8 +474,8 @@
         struct dns_entry *pDns = NULL;
         if (   cNameserversFound == 4
-            && fWarnTooManyDnsServers == 0
+            && !fWarnTooManyDnsServers
             && sscanf(buff, "nameserver%*[ \t]%255s", buff2) == 1)
         {
-            fWarnTooManyDnsServers = 1;
+            fWarnTooManyDnsServers = true;
             LogRel(("NAT: too many nameservers registered.\n"));
         }
@@ -490,5 +490,5 @@
             if (!pDns)
             {
-                LogRel(("can't alloc memory for DNS entry\n"));
+                Log(("can't alloc memory for DNS entry\n"));
                 return -1;
             }
@@ -524,9 +524,9 @@
                 if (!pDomain)
                 {
-                    LogRel(("NAT: not enought memory to add domain list\n"));
+                    Log(("NAT: not enought memory to add domain list\n"));
                     return VERR_NO_MEMORY;
                 }
                 pDomain->dd_pszDomain = RTStrDup(tok);
-                LogRel(("NAT: adding domain name %s to search list\n", pDomain->dd_pszDomain));
+                Log(("NAT: adding domain name %s to search list\n", pDomain->dd_pszDomain));
                 LIST_INSERT_HEAD(&pData->pDomainList, pDomain, dd_list);
             }
@@ -617,5 +617,5 @@
     if (rc != 0)
     {
-        LogRel(("NAT: DHCP server initialization was failed\n"));
+        Log(("NAT: DHCP server initialization was failed\n"));
         return VINF_NAT_DNS;
     }
@@ -644,5 +644,5 @@
     if (i32AliasMode & ~(PKT_ALIAS_LOG|PKT_ALIAS_SAME_PORTS|PKT_ALIAS_PROXY_ONLY))
     {
-        LogRel(("NAT: alias mode %x is ignored\n", i32AliasMode));
+        Log(("NAT: alias mode %x is ignored\n", i32AliasMode));
         i32AliasMode = 0;
     }
@@ -655,5 +655,5 @@
         if (pData->proxy_alias == NULL)
         {
-            LogRel(("NAT: LibAlias default rule wasn't initialized\n"));
+            Log(("NAT: LibAlias default rule wasn't initialized\n"));
             AssertMsgFailed(("NAT: LibAlias default rule wasn't initialized\n"));
         }
@@ -1489,5 +1489,5 @@
     if (cbBuf < ETH_HLEN)
     {
-        LogRel(("NAT: packet having size %d has been ignored\n", m->m_len));
+        Log(("NAT: packet having size %d has been ignored\n", m->m_len));
         m_freem(pData, m);
         return;
@@ -1569,5 +1569,5 @@
         if (!buf)
         {
-            LogRel(("NAT: Can't alloc memory for outgoing buffer\n"));
+            Log(("NAT: Can't alloc memory for outgoing buffer\n"));
             m_freem(pData, m);
             goto done;
@@ -1797,5 +1797,5 @@
             break;
         }
-        
+
     }
     return 0;
@@ -2001,5 +2001,5 @@
     if (m == NULL)
     {
-        LogRel(("NAT: Can't alloc mbuf for ARP request\n"));
+        Log(("NAT: Can't alloc mbuf for ARP request\n"));
         return;
     }
@@ -2055,5 +2055,5 @@
     if (ac == NULL)
     {
-        LogRel(("NAT: Can't allocate arp cache entry\n"));
+        Log(("NAT: Can't allocate arp cache entry\n"));
         return;
     }
Index: trunk/src/VBox/Devices/Network/slirp/socket.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/socket.c	(revision 33974)
+++ trunk/src/VBox/Devices/Network/slirp/socket.c	(revision 33978)
@@ -234,5 +234,5 @@
         status = ioctlsocket(so->s, FIONREAD, &pending);
         if (status < 0)
-            LogRel(("NAT:error in WSAIoctl: %d\n", errno));
+            Log(("NAT:error in WSAIoctl: %d\n", errno));
         if (nn == 0 && (pending != 0))
         {
@@ -338,5 +338,5 @@
     if (buf == NULL)
     {
-        LogRel(("NAT: can't alloc enough memory\n"));
+        Log(("NAT: can't alloc enough memory\n"));
         return -1;
     }
@@ -356,5 +356,5 @@
         status = ioctlsocket(so->s, FIONREAD, &pending);
         if (status < 0)
-            LogRel(("NAT:error in WSAIoctl: %d\n", errno));
+            Log(("NAT:error in WSAIoctl: %d\n", errno));
         if (n == 0 && (pending != 0))
         {
@@ -653,7 +653,5 @@
     n = send(so->s, sbuf_data(sb), len, (fUrg ? MSG_OOB : 0));
     if (n < 0)
-    {
-        LogRel(("NAT: Can't sent sbuf via socket.\n"));
-    }
+        Log(("NAT: Can't sent sbuf via socket.\n"));
     if (fUrg)
         so->so_urgc -= n;
@@ -665,5 +663,5 @@
         if (buff == NULL)
         {
-            LogRel(("NAT: No space to allocate temporal buffer\n"));
+            Log(("NAT: No space to allocate temporal buffer\n"));
             return -1;
         }